////////////////////////////////////////////////////////////////
//Aufgabe 5c aus Kapitel Bibliothken
//Beispiel für toxiclips Geometrie- und Physikbibliothek
//Fadenpendel mit äußerer Kraft durch Mausklick
///////////////////////////////////////////////////////////////
import toxi.physics2d.*;
import toxi.physics2d.behaviors.*;
import toxi.geom.*;


VerletPhysics2D physics;
AttractionBehavior2D mouseAttractor;
AttractionBehavior2D zufallAttractor;
int i =0;
float laenge  = 4;
int anzahlSeg =65;
float fHaerte = 1.9;
Vec2D mousePos;
Vec2D zufallPos;
boolean kraftZeichnen = false;

VerletSpring2D [] seil = new VerletSpring2D[anzahlSeg];
Masse [] m = new Masse[anzahlSeg+1] ;


void setup(){
  size(1000, 1000);
  background(255);
  stroke(70);
  //Massenpunkte initialisieren
  m[0] = new Masse(new Vec2D(width/2, height/2),0,10,color(0));
  m[0].lock();//Aufhängung: m[0] bewegt sich nicht
  for(int i =1;i<anzahlSeg;i++){
    m[i]= new Masse(new Vec2D(random(100,900),random(100,300)),0.01,1,color(0));
  }
  m[anzahlSeg]= new Masse(new Vec2D(random(100,900),random(100,300)),1,40,color(0,0,255));
  //Seilstücke initialisieren
  for(int i =0;i<anzahlSeg;i++){
    seil[i]= new VerletSpring2D(m[i], m[i+1], laenge, fHaerte);
  }
  //Physik-Bibliothek initialisieren
  physics = new VerletPhysics2D();
  physics.setWorldBounds(new Rect(0, 0, width, height));
  
  //Gravitationskraft F = (0,0.1) zeigt senkrecht nach unten
  physics.addBehavior(new GravityBehavior2D(new Vec2D(0, 0.1)));//(0,0.05)
  
  //Massenpunkte und Seilstücke in die Welt bringen
  for(int i =0;i<anzahlSeg+1;i++){
    physics.addParticle(m[i]);
  }
  for(int i =0;i<anzahlSeg;i++){
     physics.addSpring(seil[i]);
  }
}

void draw(){
   //Positionen aller Massenpunkte und Federn im Laufe der Zeit
  i++;   
  background(255);
  if(kraftZeichnen){
    fill(0);
    ellipse(zufallPos.x,zufallPos.y,20,20);
  }
   if(mousePressed){
    fill(0);
    ellipse(mousePos.x,mousePos.y,20,20);
  }
  physics.update();
  strokeWeight(3);
  
  for(int i =0;i<anzahlSeg;i++){
     line(m[i].x,m[i].y,m[i+1].x,m[i+1].y);
  }
  //Nur der Aufhängepunkt und die Masse am Ende müssen gezeichnet werden
  m[0].display();
  m[anzahlSeg].display();
}

void mousePressed(){
   mousePos = new Vec2D(mouseX, mouseY);
   // Kraftfeld an mausPos mit Stärke 2 und Wirkweite 900
  mouseAttractor = new AttractionBehavior2D(mousePos, 900, 10);
  physics.addBehavior(mouseAttractor);
}

void mouseDragged() {
  // Kraftfeld Position updaten
  mousePos.set(mouseX, mouseY);
}

void mouseReleased() {
   // Kraftfeld entfernen
  physics.removeBehavior(mouseAttractor);
}


void keyPressed(){
  if(key=='s'){
    saveFrame("Fadenpendel.jpg");
  }
}